/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2013 by Kijineko Inc.
 * 
 *  $B>e5-Cx:n8"<T$O!$0J2<$N(B(1)$B!A(B(4)$B$N>r7o$rK~$?$9>l9g$K8B$j!$K\%=%U%H%&%'(B
 *  $B%"!JK\%=%U%H%&%'%"$r2~JQ$7$?$b$N$r4^$`!%0J2<F1$8!K$r;HMQ!&J#@=!&2~(B
 *  $BJQ!&:FG[I[!J0J2<!$MxMQ$H8F$V!K$9$k$3$H$rL5=~$G5vBz$9$k!%(B
 *  (1) $BK\%=%U%H%&%'%"$r%=!<%9%3!<%I$N7A$GMxMQ$9$k>l9g$K$O!$>e5-$NCx:n(B
 *      $B8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-$NL5J]>Z5,Dj$,!$$=$N$^$^$N7A$G%=!<(B
 *      $B%9%3!<%ICf$K4^$^$l$F$$$k$3$H!%(B
 *  (2) $BK\%=%U%H%&%'%"$r!$%i%$%V%i%j7A<0$J$I!$B>$N%=%U%H%&%'%"3+H/$K;H(B
 *      $BMQ$G$-$k7A$G:FG[I[$9$k>l9g$K$O!$:FG[I[$KH<$&%I%-%e%a%s%H!JMxMQ(B
 *      $B<T%^%K%e%"%k$J$I!K$K!$>e5-$NCx:n8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-(B
 *      $B$NL5J]>Z5,Dj$r7G:\$9$k$3$H!%(B
 *  (3) $BK\%=%U%H%&%'%"$r!$5!4o$KAH$_9~$`$J$I!$B>$N%=%U%H%&%'%"3+H/$K;H(B
 *      $BMQ$G$-$J$$7A$G:FG[I[$9$k>l9g$K$O!$<!$N$$$:$l$+$N>r7o$rK~$?$9$3(B
 *      $B$H!%(B
 *    (a) $B:FG[I[$KH<$&%I%-%e%a%s%H!JMxMQ<T%^%K%e%"%k$J$I!K$K!$>e5-$NCx(B
 *        $B:n8"I=<(!$$3$NMxMQ>r7o$*$h$S2<5-$NL5J]>Z5,Dj$r7G:\$9$k$3$H!%(B
 *    (b) $B:FG[I[$N7ABV$r!$JL$KDj$a$kJ}K!$K$h$C$F!$(BTOPPERS$B%W%m%8%'%/%H$K(B
 *        $BJs9p$9$k$3$H!%(B
 *  (4) $BK\%=%U%H%&%'%"$NMxMQ$K$h$jD>@\E*$^$?$O4V@\E*$K@8$8$k$$$+$J$kB;(B
 *      $B32$+$i$b!$>e5-Cx:n8"<T$*$h$S(BTOPPERS$B%W%m%8%'%/%H$rLH@U$9$k$3$H!%(B
 *      $B$^$?!$K\%=%U%H%&%'%"$N%f!<%6$^$?$O%(%s%I%f!<%6$+$i$N$$$+$J$kM}(B
 *      $BM3$K4p$E$/@A5a$+$i$b!$>e5-Cx:n8"<T$*$h$S(BTOPPERS$B%W%m%8%'%/%H$r(B
 *      $BLH@U$9$k$3$H!%(B
 * 
 *  $BK\%=%U%H%&%'%"$O!$L5J]>Z$GDs6!$5$l$F$$$k$b$N$G$"$k!%>e5-Cx:n8"<T$*(B
 *  $B$h$S(BTOPPERS$B%W%m%8%'%/%H$O!$K\%=%U%H%&%'%"$K4X$7$F!$FCDj$N;HMQL\E*(B
 *  $B$KBP$9$kE,9g@-$b4^$a$F!$$$$+$J$kJ]>Z$b9T$o$J$$!%$^$?!$K\%=%U%H%&%'(B
 *  $B%"$NMxMQ$K$h$jD>@\E*$^$?$O4V@\E*$K@8$8$?$$$+$J$kB;32$K4X$7$F$b!$$=(B
 *  $B$N@UG$$rIi$o$J$$!%(B
 * 
 *  $Id: libc_syscall.c 58 2013-04-12 00:36:18Z ertl-honda $
 */

/*
 *  Newlib$B$N(Bmalloc/free$B$r;H$&$?$a$N2<@A$14X?t(B
 *  $BB>$N4D6-$K0\?"$9$k>l9g$O!"%i%$%V%i%j$N;EMM$K9g$o$;$F<BAu$7$J$*$9(B
 *  $BI,MW$,$"$k!#(B
 */

#include <reent.h>
#include <unistd.h>
#include <kernel.h>
#include "kernel_cfg.h"

/* $B%R!<%W%5%$%:(B */
#ifndef HEAP_SIZE
# define HEAP_SIZE 0x100000
#endif

void *_sbrk_r(struct _reent *ptr, ptrdiff_t incr)
{
  static uint64_t storage[HEAP_SIZE / sizeof(uint64_t)];
  static size_t pos = 0;
  char *result;

  if (pos + incr >= sizeof(storage))
    return NULL;

  incr = (incr + sizeof(uint64_t) - 1) / sizeof(uint64_t) * sizeof(uint64_t);
  result = (char*)storage + pos;
  pos += incr;
  return result;
}

void __malloc_lock (struct _reent *ptr)
{
  (void)ptr;
  if (!sns_ker())
    dis_dsp();
}

void __malloc_unlock (struct _reent *ptr)
{
  (void)ptr;
  if (!sns_ker())
    ena_dsp();
}

